<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" 
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:xs="http://www.w3.org/2001/XMLSchema"
		  xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
    <xsl:strip-space elements="*"/>
    <xsl:output method="text" /> 

<!-- Copyright Kathleen Dollard 2002 -->
    
	<!--Named Templates - subroutines -->
	<xsl:template name="CommaIfNotFirst">
		<!--Assume context is a for-each -->
		<xsl:if test="position()!=1">, </xsl:if>
	</xsl:template>
	
	<xsl:template name="CommaIfNotLast">
		<!--Assume context is a for-each -->
		<!--This is probably not as efficient as testing for first -->
		<xsl:if test="position()!=last()">, </xsl:if>
	</xsl:template>

	
	<!-- ************************************************************************************* (ugly stuff)
	     The remaining two templates are a tad ugly. They are currently used only to support 
		  translation from an XSD to a simplified XML description, but are left in this support
		  file because they may be of use to you in some other context -->
	<xsl:template name="NETType">
		<!--If the current context contains an msdata type, we want to use it. Currently this just occurs for GUIDs
		    when this occurs, a fully qualified name is given and we (and the ADO.NET STD generator) assumes only the 
		    start is important -->
		<xsl:choose>
			<xsl:when test="@msdata:DataType"><xsl:value-of select="substring-after(substring-before(@msdata:DataType,','),'System.')"/></xsl:when>
			<xsl:otherwise>
				<!--Assume current context contains a type -->
				<xsl:variable name="Type" select="substring-after(@type,'xs:')"/>
				<xsl:choose>
					<xsl:when test="$Type='int'">Int32</xsl:when>
					<xsl:when test="$Type='float'">Single</xsl:when>
					<xsl:when test="$Type='decimal'">Decimal</xsl:when>
					<xsl:when test="$Type='short'">Int16</xsl:when>
					<xsl:when test="$Type='string'">String</xsl:when>
					<xsl:when test="$Type='base64Binary'">Byte()</xsl:when>
					<xsl:when test="$Type='long'">Int64</xsl:when>
					<xsl:when test="$Type='boolean'">Boolean</xsl:when>
					<xsl:when test="$Type='dateTime'">DateTime</xsl:when>
					<xsl:when test="$Type='double'">Double</xsl:when>
					<xsl:when test="$Type='unsignedByte'">Byte</xsl:when>
					<xsl:when test="$Type='string'">String</xsl:when>
					<xsl:when test="$Type='string'">String</xsl:when>
					<xsl:otherwise><xsl:value-of select="$Type"/></xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="NETToVBType">
		<!-- I prefer the NET types, but if you want to convert to VB types, you can use this template -->
		<xsl:param name="Type"/>
			<xsl:choose>
				<xsl:when test="$Type='Int32'">Integer</xsl:when>
				<xsl:when test="$Type='Int16'">Short</xsl:when>
				<xsl:when test="$Type='Int64'">Long</xsl:when>
				<xsl:when test="$Type='DateTime'">Date</xsl:when>
				<xsl:otherwise><xsl:value-of select="$Type"/></xsl:otherwise>
			</xsl:choose>
	</xsl:template>

	
	<xsl:template name="FixKeywords">
	   <xsl:param name="Identifier"/>
	   
	   <!-- Change to lower case for case sensitive comparison, may not be required for C# -->
	   <xsl:variable name="lcaseID" select="translate($Identifier,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
	   
	   <!-- Lookup indentifier in a list of keywords built from the help entry 'Word Choice'. There may still be conflicts with project wide imports. -->
		<xsl:if test="contains(' addhandler addressof alias and ansi as assembly auto base boolean byref byte byval call case catch cbool cbyte cchar cdate cdec cdbl char cint class clng cobj const cshort csng cstr ctype date decimal declare default delegate dim do double each else elseif end enum erase error event exit externalsource false  finalize finally  float for friend function get gettype goto handles if implements imports in inherits integer interface is let lib like long loop me mod module mustinherit mustoverride mybase myclass namespace new next not nothing notinheritable notoverridable object on option optional or overloads overridable overrides paramarray preserve private property protected public raiseevent readonly redim region rem removehandler resume return select set shadows shared short single static step stop string structure sub synclock then throw to true try typeof unicode until volatile when while with withevents writeonly xor eval extends instanceof package var ', 
					concat(' ',$lcaseID,' '))">_</xsl:if><xsl:value-of select="$Identifier"/>
	</xsl:template>	

    
</xsl:stylesheet>

  