package training.ant.task;

import java.io.File;
import java.util.Date;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class Ls2CsvTask extends Task {
  private List filesets;
  private Mapper mapper;
  private File toFile;

  public void execute() throws BuildException {

	  pw.print("path;length;mode;lastmodified");
while(true){
	  String mappedpath;
	  if(mapper!=null) {
		  mappedpath=mapper.map(file.getAbsolutePath());
	} else {
		mappedpath=file.getAbsolutePath();
	}
		pw.print(mappedpath);
	pw.print(";");
	  pw.print(file.length());
	  pw.print(";");
	  if(file.canRead()) pw.print("r");
	  if(file.canWrite()) pw.print("w");
	  pw.print(";");
	  pw.print(new Date(file.lastModified()).toString());
	  pw.println();
  }  
  }

  public void setToFile(File file) {
	  this.toFile=file;
  }

  public void addFileset(Fileset fs) {
    if(filesets==null) filesets=new List();
    filesets.add(fs);
  }

  public void setMapper(Mapper mapper) {
    this.mapper=mapper;
  }

}
