package remote;

import org.apache.tools.ant.*;
import java.io.*;
import java.net.*;
import java.util.Properties;
import java.util.jar.*;

public class RemoteAntHandler extends org.apache.tools.ant.Main
{
	private String _sTextString = null;
	private byte[] _bytes = null;

	private String[] _sArrayArgs = null;

	private Socket _incomingSocket = null;

	private BufferedReader _bufferedReader = null;
	private PrintWriter _printWriter = null;
	private Properties _properties = null;

	public RemoteAntHandler(String[] args, Properties properties, Socket incomingSocket)
	{
		super(args);

		_properties = properties;
		_sArrayArgs = args;

		_incomingSocket = incomingSocket;

		try
		{
			// Get the reader and writer setup
			ObjectInputStream ois = new ObjectInputStream( incomingSocket.getInputStream() );

			Command inputCommand = (Command) ois.readObject();
			ois.close();

			String sCommand = inputCommand.getCommand();


			if ( sCommand.equals(Command.COPY) )
			{
				String sFilename = inputCommand.getFilename();

				writeFile(inputCommand.getByteArray(), sFilename);
			}
			else if (sCommand.equals(Command.ANT))
			{
				callAnt();
			}

			System.out.println("Shutting down thread");
		}
		catch ( IOException ioe)
		{
			ioe.printStackTrace();
		}
		catch ( CommandException ce)
		{
			ce.printStackTrace();
		}
		catch ( ClassNotFoundException cnfE)
		{
			cnfE.printStackTrace();
		}
	}

	private void writeFile(byte[] fileData, String sFilename) throws IOException
	{
		String sBuildDir = _properties.getProperty("BUILD_DIR");

		RandomAccessFile rafO = new RandomAccessFile(sBuildDir +"/"+ sFilename, "rw");

		System.out.println("RAH bytes (write)= "+ fileData.length);

		rafO.write(fileData);

		rafO.close();
	}

	private void callAnt()
	{
		String sJavaDir = _properties.getProperty("JAVA_DIR");

		RunProcess process = new RunProcess(sJavaDir, _sArrayArgs);

		try
		{
			process.run();
		}
		catch ( IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}