package remote;

import java.net.ServerSocket;
import java.net.Socket;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

public class RemoteAntServer extends Thread
{
	private ServerSocket serverSocket = null;
	private String _sAntPath = null;
	private String[] _sArrayArgs = null;
	private final int PORT = 9090;
	private Properties _properties = null;

	public RemoteAntServer(String[] sArrayArgs)
	{
		_sArrayArgs = sArrayArgs;

		// Create the properties object properties
		_properties = new Properties();

		try
		{
			_properties.load( new FileInputStream("remote.properties") );

			String sPort = _properties.getProperty("PORT");
			_sAntPath = _properties.getProperty("ANT_PATH");
			int iPort = -1;
			try
			{
				Integer.parseInt( sPort);
			}
			catch (NumberFormatException nfe)
			{
				iPort = PORT;
			}

			System.out.println("Connection to port "+ iPort);

			serverSocket = new ServerSocket(iPort);

			System.out.println("\tConnection successful");

			this.start();
		}
		catch( IOException ioe)
		{
			ioe.printStackTrace();
		}
	}

	public void run()
	{
		while ( true)
		{
			try
			{
				System.out.println("\tAwaiting socket connection");

				Socket incomingSocket = serverSocket.accept();

				System.out.println("\tInstantiating RemoteAntHandler");

				new RemoteAntHandler( _sArrayArgs, _properties, incomingSocket);
			}
			catch ( IOException ioe)
			{
				ioe.printStackTrace();
			}
		}
	}

	public static void main(String[] args)
	{
		new RemoteAntServer(args);
	}
}