package training.rmi.hello;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;

public class HelloServer {

    static private final boolean trace=true;

    public static void main(String args[]) { 
	
        // Create and install a security manager 
        if (System.getSecurityManager() == null) { 
	    System.setSecurityManager(new RMISecurityManager()); 
        } 
        try {
		// Note that the HelloImpl does not extend UnicastRemoteObject.
	    Hello obj = new HelloImpl(Hello.EN);
	    UnicastRemoteObject.exportObject(obj, Integer.parseInt(args[2]));
	    // Bind this object instance to the name "HelloServer" 
	    Naming.rebind("//"+args[0]+":"+args[1]+"/HelloServer", obj); 
	    if(trace) System.out.println("HelloServer bound in registry"); 
        } catch (Exception e) { 
	    System.out.println("HelloImpl err: " + e.getMessage()); 
	    e.printStackTrace(); 
        } 
    } 
}
