<?xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:template match="/">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	    <meta http-equiv="Content-type" content="text/html; charset='utf-8'"/>
		<link rel="alternate" type="application/rdf+xml" title="RDF Version" href="rowset.rdf" />
		<link rel="stylesheet" type="text/css" href="rowset.css" />
    </head>
	<body class="page">
		<xsl:apply-templates/>
	</body>
    </html>
  </xsl:template>

    <xsl:template match="rowset">
      <center>
	  <table border="0" cellpadding="4">
		<xsl:choose>
			<xsl:when test="row">
				<xsl:for-each select="row[1]">
					<tr>
						<xsl:for-each 
							select="*[not(starts-with(name(.),'H_'))]">
							<th align="center">
								<xsl:attribute name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 1">colodd</xsl:when>
										<xsl:when test="position() mod 2 = 0">coleven</xsl:when>
									</xsl:choose>
								</xsl:attribute>
								<xsl:value-of select="name(.)"/>
							</th>
						</xsl:for-each>
					</tr>
				</xsl:for-each>
				<xsl:for-each select="row">
					<tr>
						<xsl:attribute name="class">
							<xsl:choose>
								<xsl:when test="position() mod 2 = 1">rowodd</xsl:when>
								<xsl:when test="position() mod 2 = 0">roweven</xsl:when>
							</xsl:choose>
						</xsl:attribute>
						<xsl:for-each 
							select="*[not(starts-with(name(.),'H_'))]">
							<td>
								<xsl:attribute name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 1">colodd</xsl:when>
										<xsl:when test="position() mod 2 = 0">coleven</xsl:when>
									</xsl:choose>
								</xsl:attribute>
								<xsl:apply-templates select='.'/>
							</td>
						</xsl:for-each>
					</tr>
				</xsl:for-each>

			</xsl:when>
			<xsl:otherwise>
				<tr>
					<td>No Matches</td>
				</tr>
			</xsl:otherwise>
		</xsl:choose>
		</table>
      </center>
    </xsl:template>

    <!--
    	<xsl:template match="row">
        <tr>
          <xsl:attribute name="class">
            <xsl:choose>
              <xsl:when test="position() mod 2 = 1">rowodd</xsl:when>
              <xsl:when test="position() mod 2 = 0">roweven</xsl:when>
            </xsl:choose>
          </xsl:attribute>
          <xsl:for-each select="*[not(starts-with(name(.),'H_'))]">
            <td>
			<xsl:attribute name="class">
				<xsl:choose>
					<xsl:when test="position() mod 2 = 1">colodd</xsl:when>
					<xsl:when test="position() mod 2 = 0">coleven</xsl:when>
				</xsl:choose>
			</xsl:attribute>
              <xsl:apply-templates select='.'/>
            </td>
          </xsl:for-each>
        </tr>
  </xsl:template>
  -->

</xsl:stylesheet>
